// File:  ADTStack\StackException.java

/**
 * Realization of a Stack ADT
 * 
 * @author Bary W Pollack
 * @version Jan. 2, 2001 - 19:00 PST
 */

import java.io.*;

// An Exception class specialized for use by the Stack methods

// If you extend RuntimeException, then you are NOT forced to
// place each method call within a try-catch block.  Of course,
// in this case an UNCAUGHT exception will cause your program
// to terminate -- but, that's probably what you want to do

// If you extend Exception, instead, then you MUST place each
// method call within a try-catch block

public class StackException extends RuntimeException {

    // Default StackException
    StackException() {
        super();
    }

    // StackException just displaying normal call-stack backtrace
    StackException(String sMessage, int nUnused) {
        super(sMessage);
        StringWriter sw = new StringWriter();
        new Throwable().printStackTrace(new PrintWriter(sw));
        String callStack = sw.toString();
        int atPos  = callStack.indexOf("at ");
        atPos = callStack.indexOf("at ", atPos+1);
        System.out.println();
        System.out.println("******************************");
        System.out.print(callStack.substring(atPos-1));
    }

    // StackException displaying the call-stack backtrace in a RealJ-ready form
    StackException(String sMessage) {
        super(sMessage);
        StringWriter sw = new StringWriter();
        new Throwable().printStackTrace(new PrintWriter(sw));
        String callStack = sw.toString();
        int atPos  = callStack.indexOf("at ");
        System.out.println();
        System.out.println("******************** BACKTRACE ********************");
        String cs = callStack.substring(atPos-1);
        while (cs.length() > 12) {
            int lPos = cs.indexOf("(");
            int rPos = cs.indexOf(")");
            System.out.print(cs.substring(lPos+1, rPos) + "  from ");
            atPos = cs.indexOf("at ");
            System.out.println(cs.substring(atPos+3, lPos+1) + ")");
            cs = cs.substring(rPos+1);
        }
        System.out.println("******************** EXCEPTION ********************");
    }

}
